# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from ._enums import *
import pulumi_command

__all__ = [
    'CniBridgeIpamArgs',
    'EtcdConfigurationPropsArgs',
    'EtcdNodeArgs',
    'SystemdInstallSectionArgs',
    'SystemdServiceSectionArgs',
    'SystemdUnitSectionArgs',
]

@pulumi.input_type
class CniBridgeIpamArgs:
    def __init__(__self__, *,
                 ranges: Optional[pulumi.Input[Sequence[pulumi.Input[Mapping[str, pulumi.Input[str]]]]]] = None,
                 routes: Optional[pulumi.Input[Sequence[pulumi.Input[Mapping[str, pulumi.Input[str]]]]]] = None,
                 type: Optional[pulumi.Input[str]] = None):
        """
        The CNI plugins IPAM
        :param pulumi.Input[Sequence[pulumi.Input[Mapping[str, pulumi.Input[str]]]]] ranges: IPAM ranges.
        :param pulumi.Input[Sequence[pulumi.Input[Mapping[str, pulumi.Input[str]]]]] routes: IPAM routes.
        :param pulumi.Input[str] type: CNI bridge IPAM type
        """
        if ranges is not None:
            pulumi.set(__self__, "ranges", ranges)
        if routes is not None:
            pulumi.set(__self__, "routes", routes)
        if type is not None:
            pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def ranges(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[Mapping[str, pulumi.Input[str]]]]]]:
        """
        IPAM ranges.
        """
        return pulumi.get(self, "ranges")

    @ranges.setter
    def ranges(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[Mapping[str, pulumi.Input[str]]]]]]):
        pulumi.set(self, "ranges", value)

    @property
    @pulumi.getter
    def routes(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[Mapping[str, pulumi.Input[str]]]]]]:
        """
        IPAM routes.
        """
        return pulumi.get(self, "routes")

    @routes.setter
    def routes(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[Mapping[str, pulumi.Input[str]]]]]]):
        pulumi.set(self, "routes", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[str]]:
        """
        CNI bridge IPAM type
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "type", value)


@pulumi.input_type
class EtcdConfigurationPropsArgs:
    def __init__(__self__, *,
                 ca_file_path: pulumi.Input[str],
                 cert_file_path: pulumi.Input[str],
                 data_directory: pulumi.Input[str],
                 etcd_path: pulumi.Input[str],
                 internal_ip: pulumi.Input[str],
                 key_file_path: pulumi.Input[str],
                 name: pulumi.Input[str]):
        """
        Props for resources that consume etcd configuration.
        :param pulumi.Input[str] ca_file_path: Path to the certificate authority file on the remote system.
        :param pulumi.Input[str] cert_file_path: Path to the certificate file on the remote system.
        :param pulumi.Input[str] data_directory: Etcd's data directory.
        :param pulumi.Input[str] etcd_path: Path to the etcd binary.
        :param pulumi.Input[str] internal_ip: Internal IP of the etcd node.
        :param pulumi.Input[str] key_file_path: Path to the private key file on the remote system.
        :param pulumi.Input[str] name: Name of the etcd node.
        """
        pulumi.set(__self__, "ca_file_path", ca_file_path)
        pulumi.set(__self__, "cert_file_path", cert_file_path)
        pulumi.set(__self__, "data_directory", data_directory)
        pulumi.set(__self__, "etcd_path", etcd_path)
        pulumi.set(__self__, "internal_ip", internal_ip)
        pulumi.set(__self__, "key_file_path", key_file_path)
        pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter(name="caFilePath")
    def ca_file_path(self) -> pulumi.Input[str]:
        """
        Path to the certificate authority file on the remote system.
        """
        return pulumi.get(self, "ca_file_path")

    @ca_file_path.setter
    def ca_file_path(self, value: pulumi.Input[str]):
        pulumi.set(self, "ca_file_path", value)

    @property
    @pulumi.getter(name="certFilePath")
    def cert_file_path(self) -> pulumi.Input[str]:
        """
        Path to the certificate file on the remote system.
        """
        return pulumi.get(self, "cert_file_path")

    @cert_file_path.setter
    def cert_file_path(self, value: pulumi.Input[str]):
        pulumi.set(self, "cert_file_path", value)

    @property
    @pulumi.getter(name="dataDirectory")
    def data_directory(self) -> pulumi.Input[str]:
        """
        Etcd's data directory.
        """
        return pulumi.get(self, "data_directory")

    @data_directory.setter
    def data_directory(self, value: pulumi.Input[str]):
        pulumi.set(self, "data_directory", value)

    @property
    @pulumi.getter(name="etcdPath")
    def etcd_path(self) -> pulumi.Input[str]:
        """
        Path to the etcd binary.
        """
        return pulumi.get(self, "etcd_path")

    @etcd_path.setter
    def etcd_path(self, value: pulumi.Input[str]):
        pulumi.set(self, "etcd_path", value)

    @property
    @pulumi.getter(name="internalIp")
    def internal_ip(self) -> pulumi.Input[str]:
        """
        Internal IP of the etcd node.
        """
        return pulumi.get(self, "internal_ip")

    @internal_ip.setter
    def internal_ip(self, value: pulumi.Input[str]):
        pulumi.set(self, "internal_ip", value)

    @property
    @pulumi.getter(name="keyFilePath")
    def key_file_path(self) -> pulumi.Input[str]:
        """
        Path to the private key file on the remote system.
        """
        return pulumi.get(self, "key_file_path")

    @key_file_path.setter
    def key_file_path(self, value: pulumi.Input[str]):
        pulumi.set(self, "key_file_path", value)

    @property
    @pulumi.getter
    def name(self) -> pulumi.Input[str]:
        """
        Name of the etcd node.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: pulumi.Input[str]):
        pulumi.set(self, "name", value)


@pulumi.input_type
class EtcdNodeArgs:
    def __init__(__self__, *,
                 connection: pulumi.Input['pulumi_command.remote.ConnectionArgs'],
                 internal_ip: pulumi.Input[str],
                 architecture: Optional[pulumi.Input['Architecture']] = None):
        """
        Etcd node description.
        :param pulumi.Input['pulumi_command.remote.ConnectionArgs'] connection: The parameters with which to connect to the remote host.
        :param pulumi.Input[str] internal_ip: The internal IP of the node.
        :param pulumi.Input['Architecture'] architecture: The CPU architecture of the node.
        """
        pulumi.set(__self__, "connection", connection)
        pulumi.set(__self__, "internal_ip", internal_ip)
        if architecture is not None:
            pulumi.set(__self__, "architecture", architecture)

    @property
    @pulumi.getter
    def connection(self) -> pulumi.Input['pulumi_command.remote.ConnectionArgs']:
        """
        The parameters with which to connect to the remote host.
        """
        return pulumi.get(self, "connection")

    @connection.setter
    def connection(self, value: pulumi.Input['pulumi_command.remote.ConnectionArgs']):
        pulumi.set(self, "connection", value)

    @property
    @pulumi.getter(name="internalIp")
    def internal_ip(self) -> pulumi.Input[str]:
        """
        The internal IP of the node.
        """
        return pulumi.get(self, "internal_ip")

    @internal_ip.setter
    def internal_ip(self, value: pulumi.Input[str]):
        pulumi.set(self, "internal_ip", value)

    @property
    @pulumi.getter
    def architecture(self) -> Optional[pulumi.Input['Architecture']]:
        """
        The CPU architecture of the node.
        """
        return pulumi.get(self, "architecture")

    @architecture.setter
    def architecture(self, value: Optional[pulumi.Input['Architecture']]):
        pulumi.set(self, "architecture", value)


@pulumi.input_type
class SystemdInstallSectionArgs:
    def __init__(__self__, *,
                 wanted_by: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        https://www.freedesktop.org/software/systemd/man/latest/systemd.unit.html#%5BInstall%5D%20Section%20Options
        :param pulumi.Input[Sequence[pulumi.Input[str]]] wanted_by: A symbolic link is created in the .wants/, .requires/, or .upholds/ directory of each of the listed units when this unit is installed by systemctl enable.
        """
        if wanted_by is not None:
            pulumi.set(__self__, "wanted_by", wanted_by)

    @property
    @pulumi.getter(name="wantedBy")
    def wanted_by(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        A symbolic link is created in the .wants/, .requires/, or .upholds/ directory of each of the listed units when this unit is installed by systemctl enable.
        """
        return pulumi.get(self, "wanted_by")

    @wanted_by.setter
    def wanted_by(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "wanted_by", value)


@pulumi.input_type
class SystemdServiceSectionArgs:
    def __init__(__self__, *,
                 exec_start: Optional[pulumi.Input[str]] = None,
                 exit_type: Optional[pulumi.Input['SystemdServiceExitType']] = None,
                 restart: Optional[pulumi.Input['SystemdServiceRestart']] = None,
                 restart_sec: Optional[pulumi.Input[str]] = None,
                 type: Optional[pulumi.Input['SystemdServiceType']] = None):
        """
        https://www.freedesktop.org/software/systemd/man/latest/systemd.service.html#
        :param pulumi.Input[str] exec_start: Commands that are executed when this service is started.
        :param pulumi.Input['SystemdServiceExitType'] exit_type: Specifies when the manager should consider the service to be finished.
        :param pulumi.Input['SystemdServiceRestart'] restart: Configures whether the service shall be restarted when the service process exits, is killed, or a timeout is reached.
        :param pulumi.Input[str] restart_sec: Configures the time to sleep before restarting a service (as configured with Restart=).
        :param pulumi.Input['SystemdServiceType'] type: Configures the mechanism via which the service notifies the manager that the service start-up has finished.
        """
        if exec_start is not None:
            pulumi.set(__self__, "exec_start", exec_start)
        if exit_type is not None:
            pulumi.set(__self__, "exit_type", exit_type)
        if restart is not None:
            pulumi.set(__self__, "restart", restart)
        if restart_sec is not None:
            pulumi.set(__self__, "restart_sec", restart_sec)
        if type is not None:
            pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="execStart")
    def exec_start(self) -> Optional[pulumi.Input[str]]:
        """
        Commands that are executed when this service is started.
        """
        return pulumi.get(self, "exec_start")

    @exec_start.setter
    def exec_start(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "exec_start", value)

    @property
    @pulumi.getter(name="exitType")
    def exit_type(self) -> Optional[pulumi.Input['SystemdServiceExitType']]:
        """
        Specifies when the manager should consider the service to be finished.
        """
        return pulumi.get(self, "exit_type")

    @exit_type.setter
    def exit_type(self, value: Optional[pulumi.Input['SystemdServiceExitType']]):
        pulumi.set(self, "exit_type", value)

    @property
    @pulumi.getter
    def restart(self) -> Optional[pulumi.Input['SystemdServiceRestart']]:
        """
        Configures whether the service shall be restarted when the service process exits, is killed, or a timeout is reached.
        """
        return pulumi.get(self, "restart")

    @restart.setter
    def restart(self, value: Optional[pulumi.Input['SystemdServiceRestart']]):
        pulumi.set(self, "restart", value)

    @property
    @pulumi.getter(name="restartSec")
    def restart_sec(self) -> Optional[pulumi.Input[str]]:
        """
        Configures the time to sleep before restarting a service (as configured with Restart=).
        """
        return pulumi.get(self, "restart_sec")

    @restart_sec.setter
    def restart_sec(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "restart_sec", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input['SystemdServiceType']]:
        """
        Configures the mechanism via which the service notifies the manager that the service start-up has finished.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input['SystemdServiceType']]):
        pulumi.set(self, "type", value)


@pulumi.input_type
class SystemdUnitSectionArgs:
    def __init__(__self__, *,
                 binds_to: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 documentation: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 requires: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 requisite: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 wants: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        https://www.freedesktop.org/software/systemd/man/latest/systemd.unit.html#
        :param pulumi.Input[Sequence[pulumi.Input[str]]] binds_to: Configures requirement dependencies, very similar in style to Requires=.
        :param pulumi.Input[str] description: A short human readable title of the unit.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] documentation: A space-separated list of URIs referencing documentation for this unit or its configuration.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] requires: Similar to Wants=, but declares a stronger requirement dependency.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] requisite: Similar to Requires=. However, if the units listed here are not started already, they will not be started and the starting of this unit will fail immediately.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] wants: Configures (weak) requirement dependencies on other units.
        """
        if binds_to is not None:
            pulumi.set(__self__, "binds_to", binds_to)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if documentation is not None:
            pulumi.set(__self__, "documentation", documentation)
        if requires is not None:
            pulumi.set(__self__, "requires", requires)
        if requisite is not None:
            pulumi.set(__self__, "requisite", requisite)
        if wants is not None:
            pulumi.set(__self__, "wants", wants)

    @property
    @pulumi.getter(name="bindsTo")
    def binds_to(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Configures requirement dependencies, very similar in style to Requires=.
        """
        return pulumi.get(self, "binds_to")

    @binds_to.setter
    def binds_to(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "binds_to", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        A short human readable title of the unit.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def documentation(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        A space-separated list of URIs referencing documentation for this unit or its configuration.
        """
        return pulumi.get(self, "documentation")

    @documentation.setter
    def documentation(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "documentation", value)

    @property
    @pulumi.getter
    def requires(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Similar to Wants=, but declares a stronger requirement dependency.
        """
        return pulumi.get(self, "requires")

    @requires.setter
    def requires(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "requires", value)

    @property
    @pulumi.getter
    def requisite(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Similar to Requires=. However, if the units listed here are not started already, they will not be started and the starting of this unit will fail immediately.
        """
        return pulumi.get(self, "requisite")

    @requisite.setter
    def requisite(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "requisite", value)

    @property
    @pulumi.getter
    def wants(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Configures (weak) requirement dependencies on other units.
        """
        return pulumi.get(self, "wants")

    @wants.setter
    def wants(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "wants", value)


