# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *
from .file import File
import pulumi_command

__all__ = ['CniBridgePluginConfigurationArgs', 'CniBridgePluginConfiguration']

@pulumi.input_type
class CniBridgePluginConfigurationArgs:
    def __init__(__self__, *,
                 connection: pulumi.Input['pulumi_command.remote.ConnectionArgs'],
                 bridge: Optional[pulumi.Input[str]] = None,
                 cni_version: Optional[pulumi.Input[str]] = None,
                 ip_masq: Optional[pulumi.Input[bool]] = None,
                 ipam: Optional[pulumi.Input['CniBridgeIpamArgs']] = None,
                 is_gateway: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 path: Optional[pulumi.Input[str]] = None,
                 subnet: Optional[pulumi.Input[str]] = None,
                 type: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a CniBridgePluginConfiguration resource.
        :param pulumi.Input['pulumi_command.remote.ConnectionArgs'] connection: The parameters with which to connect to the remote host.
        :param pulumi.Input[str] bridge: Bridge name.
        :param pulumi.Input[str] cni_version: CNI version.
        :param pulumi.Input[bool] ip_masq: IP masq.
        :param pulumi.Input['CniBridgeIpamArgs'] ipam: IPAM
        :param pulumi.Input[bool] is_gateway: Is gateway.
        :param pulumi.Input[str] name: CNI plugin name.
        :param pulumi.Input[str] path: Path to put the configuration file on the remote system
        :param pulumi.Input[str] subnet: The subnet to use.
        :param pulumi.Input[str] type: CNI plugin type.
        """
        pulumi.set(__self__, "connection", connection)
        if bridge is not None:
            pulumi.set(__self__, "bridge", bridge)
        if cni_version is not None:
            pulumi.set(__self__, "cni_version", cni_version)
        if ip_masq is not None:
            pulumi.set(__self__, "ip_masq", ip_masq)
        if ipam is not None:
            pulumi.set(__self__, "ipam", ipam)
        if is_gateway is not None:
            pulumi.set(__self__, "is_gateway", is_gateway)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if path is not None:
            pulumi.set(__self__, "path", path)
        if subnet is not None:
            pulumi.set(__self__, "subnet", subnet)
        if type is not None:
            pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def connection(self) -> pulumi.Input['pulumi_command.remote.ConnectionArgs']:
        """
        The parameters with which to connect to the remote host.
        """
        return pulumi.get(self, "connection")

    @connection.setter
    def connection(self, value: pulumi.Input['pulumi_command.remote.ConnectionArgs']):
        pulumi.set(self, "connection", value)

    @property
    @pulumi.getter
    def bridge(self) -> Optional[pulumi.Input[str]]:
        """
        Bridge name.
        """
        return pulumi.get(self, "bridge")

    @bridge.setter
    def bridge(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "bridge", value)

    @property
    @pulumi.getter(name="cniVersion")
    def cni_version(self) -> Optional[pulumi.Input[str]]:
        """
        CNI version.
        """
        return pulumi.get(self, "cni_version")

    @cni_version.setter
    def cni_version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cni_version", value)

    @property
    @pulumi.getter(name="ipMasq")
    def ip_masq(self) -> Optional[pulumi.Input[bool]]:
        """
        IP masq.
        """
        return pulumi.get(self, "ip_masq")

    @ip_masq.setter
    def ip_masq(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "ip_masq", value)

    @property
    @pulumi.getter
    def ipam(self) -> Optional[pulumi.Input['CniBridgeIpamArgs']]:
        """
        IPAM
        """
        return pulumi.get(self, "ipam")

    @ipam.setter
    def ipam(self, value: Optional[pulumi.Input['CniBridgeIpamArgs']]):
        pulumi.set(self, "ipam", value)

    @property
    @pulumi.getter(name="isGateway")
    def is_gateway(self) -> Optional[pulumi.Input[bool]]:
        """
        Is gateway.
        """
        return pulumi.get(self, "is_gateway")

    @is_gateway.setter
    def is_gateway(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_gateway", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        CNI plugin name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def path(self) -> Optional[pulumi.Input[str]]:
        """
        Path to put the configuration file on the remote system
        """
        return pulumi.get(self, "path")

    @path.setter
    def path(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "path", value)

    @property
    @pulumi.getter
    def subnet(self) -> Optional[pulumi.Input[str]]:
        """
        The subnet to use.
        """
        return pulumi.get(self, "subnet")

    @subnet.setter
    def subnet(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "subnet", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[str]]:
        """
        CNI plugin type.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "type", value)


class CniBridgePluginConfiguration(pulumi.ComponentResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 bridge: Optional[pulumi.Input[str]] = None,
                 cni_version: Optional[pulumi.Input[str]] = None,
                 connection: Optional[pulumi.Input[pulumi.InputType['pulumi_command.remote.ConnectionArgs']]] = None,
                 ip_masq: Optional[pulumi.Input[bool]] = None,
                 ipam: Optional[pulumi.Input[pulumi.InputType['CniBridgeIpamArgs']]] = None,
                 is_gateway: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 path: Optional[pulumi.Input[str]] = None,
                 subnet: Optional[pulumi.Input[str]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        The CNI bridge plugin configuration.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] bridge: Bridge name.
        :param pulumi.Input[str] cni_version: CNI version.
        :param pulumi.Input[pulumi.InputType['pulumi_command.remote.ConnectionArgs']] connection: The parameters with which to connect to the remote host.
        :param pulumi.Input[bool] ip_masq: IP masq.
        :param pulumi.Input[pulumi.InputType['CniBridgeIpamArgs']] ipam: IPAM
        :param pulumi.Input[bool] is_gateway: Is gateway.
        :param pulumi.Input[str] name: CNI plugin name.
        :param pulumi.Input[str] path: Path to put the configuration file on the remote system
        :param pulumi.Input[str] subnet: The subnet to use.
        :param pulumi.Input[str] type: CNI plugin type.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: CniBridgePluginConfigurationArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The CNI bridge plugin configuration.

        :param str resource_name: The name of the resource.
        :param CniBridgePluginConfigurationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(CniBridgePluginConfigurationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 bridge: Optional[pulumi.Input[str]] = None,
                 cni_version: Optional[pulumi.Input[str]] = None,
                 connection: Optional[pulumi.Input[pulumi.InputType['pulumi_command.remote.ConnectionArgs']]] = None,
                 ip_masq: Optional[pulumi.Input[bool]] = None,
                 ipam: Optional[pulumi.Input[pulumi.InputType['CniBridgeIpamArgs']]] = None,
                 is_gateway: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 path: Optional[pulumi.Input[str]] = None,
                 subnet: Optional[pulumi.Input[str]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is not None:
            raise ValueError('ComponentResource classes do not support opts.id')
        else:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = CniBridgePluginConfigurationArgs.__new__(CniBridgePluginConfigurationArgs)

            __props__.__dict__["bridge"] = bridge
            __props__.__dict__["cni_version"] = cni_version
            if connection is None and not opts.urn:
                raise TypeError("Missing required property 'connection'")
            __props__.__dict__["connection"] = connection
            __props__.__dict__["ip_masq"] = ip_masq
            __props__.__dict__["ipam"] = ipam
            __props__.__dict__["is_gateway"] = is_gateway
            __props__.__dict__["name"] = name
            __props__.__dict__["path"] = path
            __props__.__dict__["subnet"] = subnet
            __props__.__dict__["type"] = type
            __props__.__dict__["file"] = None
        super(CniBridgePluginConfiguration, __self__).__init__(
            'kubernetes-the-hard-way:remote:CniBridgePluginConfiguration',
            resource_name,
            __props__,
            opts,
            remote=True)

    @property
    @pulumi.getter
    def bridge(self) -> pulumi.Output[str]:
        """
        Bridge name.
        """
        return pulumi.get(self, "bridge")

    @property
    @pulumi.getter(name="cniVersion")
    def cni_version(self) -> pulumi.Output[str]:
        """
        CNI version.
        """
        return pulumi.get(self, "cni_version")

    @property
    @pulumi.getter
    def connection(self) -> pulumi.Output['pulumi_command.remote.outputs.Connection']:
        """
        The parameters with which to connect to the remote host.
        """
        return pulumi.get(self, "connection")

    @property
    @pulumi.getter
    def file(self) -> pulumi.Output[Optional['File']]:
        """
        The file on the remote system.
        """
        return pulumi.get(self, "file")

    @property
    @pulumi.getter(name="ipMasq")
    def ip_masq(self) -> pulumi.Output[bool]:
        """
        IP masq.
        """
        return pulumi.get(self, "ip_masq")

    @property
    @pulumi.getter
    def ipam(self) -> pulumi.Output['outputs.CniBridgeIpam']:
        """
        IPAM
        """
        return pulumi.get(self, "ipam")

    @property
    @pulumi.getter(name="isGateway")
    def is_gateway(self) -> pulumi.Output[bool]:
        """
        Is gateway.
        """
        return pulumi.get(self, "is_gateway")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        CNI plugin name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def path(self) -> pulumi.Output[str]:
        """
        Path to put the configuration file on the remote system
        """
        return pulumi.get(self, "path")

    @property
    @pulumi.getter
    def subnet(self) -> pulumi.Output[Optional[str]]:
        """
        The subnet to use.
        """
        return pulumi.get(self, "subnet")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        CNI plugin type.
        """
        return pulumi.get(self, "type")

