# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from .file import File
import pulumi_command

__all__ = ['CniLoopbackPluginConfigurationArgs', 'CniLoopbackPluginConfiguration']

@pulumi.input_type
class CniLoopbackPluginConfigurationArgs:
    def __init__(__self__, *,
                 connection: pulumi.Input['pulumi_command.remote.ConnectionArgs'],
                 cni_version: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 path: Optional[pulumi.Input[str]] = None,
                 type: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a CniLoopbackPluginConfiguration resource.
        :param pulumi.Input['pulumi_command.remote.ConnectionArgs'] connection: The parameters with which to connect to the remote host.
        :param pulumi.Input[str] cni_version: CNI version.
        :param pulumi.Input[str] name: CNI plugin name.
        :param pulumi.Input[str] path: Path to put the configuration file on the remote system
        :param pulumi.Input[str] type: CNI plugin type.
        """
        pulumi.set(__self__, "connection", connection)
        if cni_version is not None:
            pulumi.set(__self__, "cni_version", cni_version)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if path is not None:
            pulumi.set(__self__, "path", path)
        if type is not None:
            pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def connection(self) -> pulumi.Input['pulumi_command.remote.ConnectionArgs']:
        """
        The parameters with which to connect to the remote host.
        """
        return pulumi.get(self, "connection")

    @connection.setter
    def connection(self, value: pulumi.Input['pulumi_command.remote.ConnectionArgs']):
        pulumi.set(self, "connection", value)

    @property
    @pulumi.getter(name="cniVersion")
    def cni_version(self) -> Optional[pulumi.Input[str]]:
        """
        CNI version.
        """
        return pulumi.get(self, "cni_version")

    @cni_version.setter
    def cni_version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cni_version", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        CNI plugin name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def path(self) -> Optional[pulumi.Input[str]]:
        """
        Path to put the configuration file on the remote system
        """
        return pulumi.get(self, "path")

    @path.setter
    def path(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "path", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[str]]:
        """
        CNI plugin type.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "type", value)


class CniLoopbackPluginConfiguration(pulumi.ComponentResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cni_version: Optional[pulumi.Input[str]] = None,
                 connection: Optional[pulumi.Input[pulumi.InputType['pulumi_command.remote.ConnectionArgs']]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 path: Optional[pulumi.Input[str]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        The CNI loopback plugin configuration.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] cni_version: CNI version.
        :param pulumi.Input[pulumi.InputType['pulumi_command.remote.ConnectionArgs']] connection: The parameters with which to connect to the remote host.
        :param pulumi.Input[str] name: CNI plugin name.
        :param pulumi.Input[str] path: Path to put the configuration file on the remote system
        :param pulumi.Input[str] type: CNI plugin type.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: CniLoopbackPluginConfigurationArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The CNI loopback plugin configuration.

        :param str resource_name: The name of the resource.
        :param CniLoopbackPluginConfigurationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(CniLoopbackPluginConfigurationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cni_version: Optional[pulumi.Input[str]] = None,
                 connection: Optional[pulumi.Input[pulumi.InputType['pulumi_command.remote.ConnectionArgs']]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 path: Optional[pulumi.Input[str]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is not None:
            raise ValueError('ComponentResource classes do not support opts.id')
        else:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = CniLoopbackPluginConfigurationArgs.__new__(CniLoopbackPluginConfigurationArgs)

            __props__.__dict__["cni_version"] = cni_version
            if connection is None and not opts.urn:
                raise TypeError("Missing required property 'connection'")
            __props__.__dict__["connection"] = connection
            __props__.__dict__["name"] = name
            __props__.__dict__["path"] = path
            __props__.__dict__["type"] = type
            __props__.__dict__["file"] = None
        super(CniLoopbackPluginConfiguration, __self__).__init__(
            'kubernetes-the-hard-way:remote:CniLoopbackPluginConfiguration',
            resource_name,
            __props__,
            opts,
            remote=True)

    @property
    @pulumi.getter(name="cniVersion")
    def cni_version(self) -> pulumi.Output[str]:
        """
        CNI version.
        """
        return pulumi.get(self, "cni_version")

    @property
    @pulumi.getter
    def connection(self) -> pulumi.Output['pulumi_command.remote.outputs.Connection']:
        """
        The parameters with which to connect to the remote host.
        """
        return pulumi.get(self, "connection")

    @property
    @pulumi.getter
    def file(self) -> pulumi.Output[Optional['File']]:
        """
        The file on the remote system.
        """
        return pulumi.get(self, "file")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        CNI plugin name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def path(self) -> pulumi.Output[str]:
        """
        Path to put the configuration file on the remote system
        """
        return pulumi.get(self, "path")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        CNI plugin type.
        """
        return pulumi.get(self, "type")

